//----------------------------------------------------------------------------
// VMLRENDERER 1.0
// VML Renderer For RichDraw
// Dependencies:
// History:
// 2006-04-05 | Created
// --------------------------------------------------------------------------*/


function VMLRenderer() {
	this.base = AbstractRenderer;
}


VMLRenderer.prototype = new AbstractRenderer; 

VMLRenderer.prototype.bounds = function(shape) {
  var rect = new Object();
  rect['x'] = shape.offsetLeft;
  rect['y'] = shape.offsetTop;
  rect['width'] =  shape.offsetWidth;
  rect['height'] = shape.offsetHeight;
  return rect;
}

VMLRenderer.prototype.init = function(elem) 
 {
  this.container = elem;
  // this.container.style.overflow = 'hidden';
  this.container.unselectable = "on";
  // Add VML includes and namespace
  elem.ownerDocument.namespaces.add("v", "urn:schemas-microsoft-com:vml");
  var style = elem.ownerDocument.createStyleSheet();
  style.addRule('v\\:*', "behavior: url(#default#VML); display:inline-block");
  //NOT VML biewBox
  //http://blogs.msdn.com/ie/archive/2008/03/18/webbrowser-control-rendering-modes-in-ie8.aspx 

 } 




var proporx=1;
var propory=1;

VMLRenderer.prototype.view = function(left,top,width,height,viewBox,bgcolor) {
  var tokens = viewBox.split(' '); 
       
  var margin=100; 
  var wFront=parseInt(document.getElementById('FRONT').style.width)
  var hFront=parseInt(document.getElementById('FRONT').style.height)
  var tC=0 + ' ' + 0 + ' ' + wFront + ' ' + hFront;
  tokensCanvas= tC.split(' '); 

  var w=parseFloat(tokens[2]);
  var h=parseFloat(tokens[3]); 
  var wImage = w - parseFloat(tokens[0]);  
  var hImage = h - parseFloat(tokens[1]);
  var wCanvas = wFront;
  var hCanvas = hFront;
  proporImage = hImage / wImage; 
  proporCanvas = hCanvas / wCanvas; 

  document.title= initialFile +'     '+wImage+' x '+hImage;


  if(bgcolor != '')
   {
    this.container.style.backgroundColor=bgcolor;
   } else{
    this.container.style.backgroundColor="#ffffff";
   }
if(viewMode=='preview')
 {
  if(proporCanvas==proporImage)
   {
      this.container.style.width =wFront+'px';
      this.container.style.height =hFront+'px';
      this.container.style.left =0+'px' 
      this.container.style.top =0+'px' 
      canvasLeft = 0;
   canvasTop = 0; 
   canvasWidth =wFront ;
   canvasHeight = hFront; 
   zoominit1= 0+' '+0+' '+wFront+' '+hFront;
   zoominit = viewBox;
   zoominit2 = zoominit1;  
  
  
   proporx = 1;
   propory = 1;
   
   }
  if(proporCanvas<proporImage)
   {    
      var proportion= wFront/hFront;  
      //var image_proportion= width/height;
      var image_proportion= w/h;
      var W=hFront*image_proportion; 
      var leftover=(wFront-W)/2;
      
      this.container.style.width =W+'px';
      this.container.style.height =hFront+'px';
      this.container.style.left =leftover+'px' 
      this.container.style.top =0+'px' 
      //alert('Horizontal '+wFront+','+hFront+' '+image_proportion+' '+W+' '+leftover+' ____'+ this.container.style.width)
   canvasLeft = leftover;
   canvasTop = 0; 
   canvasWidth =W ;
   canvasHeight = hFront; 
   zoominit1= viewBox;//leftover+' '+0+' '+W+' '+hFront;
   zoominit1=0+' '+0+' '+W+' '+hFront;    
   zoominit = viewBox;
   zoominit2 = zoominit1;  
  
  
   proporx = W/w;
   propory = hFront/h;
   
 
    } 
  if(proporCanvas>proporImage)
   {    
      var proportion= hFront/wFront;  
      //var image_proportion= width/height;
      var image_proportion= h/w;
      var H=wFront*image_proportion; 
      var leftover=(hFront-H)/2;
      
      this.container.style.width =wFront+'px';
      this.container.style.height =H+'px';
      this.container.style.left =0+'px' 
      this.container.style.top =leftover+'px'   
      
   canvasLeft = 0;
   canvasTop = leftover; 
   canvasWidth = wFront;
   canvasHeight = H; 
   //zoominit1 = 0+' '+leftover+' '+wFront+' '+H;
   zoominit1 = 0+' '+0+' '+wFront+' '+H;    
   zoominit = viewBox;
   zoominit2 = viewBox;//zoominit1;  

   proporx = wFront/w;
   propory = H/h;
 
    }   
     // proporx = width/tokens[2];
     //propory = height/tokens[2];


   
  } 
if(viewMode=='canvas')
 {
   this.container.style.left = 0 + 'px';   
   this.container.style.top = 0 + 'px';                                 
   this.container.style.width = wFront + 'px';
   this.container.style.height = hFront + 'px';
   
   //  margins 10%    
   var percent=10;
   var percentX = wImage / percent; 
   var percentY = hImage / percent; 
   var cornerNEx = parseFloat(tokens[0])-percentX; 
   var cornerNEy = parseFloat(tokens[1])-percentY;
   var percentRectW=wImage + percentX*2;
   var percentRectH=hImage + percentY*2; 
 
   document.title= initialFile +'     '+wImage+' x '+hImage;
   // ajust proporImage to proporCanvas
  if(proporCanvas==proporImage)
   {  
      cornerNEx = parseFloat(tokens[0])-percentX
      cornerNEy = parseFloat(tokens[1])-percentY  
      var wi=percentRectW;
      var he=percentRectH;//hImage+percentY+addHimage; 
      zoominit=viewBox;
      zoominit1 = (-percentX) +' '+(-percentY)+' '+wi+' '+he;
      proporx =(w*(100-percent*2)/100)/w;
      propory =( h*(100-percent*2)/100)/h; 
      zoominit2=zoominit1; 
      tokensZoom=tokensCanvas;//viewBox.split(' '); ;//zoominit1.split(' '); 
      
   }

  if(proporCanvas<proporImage)
   {    
        
        // add to hImage
        var newWimage = percentRectW * ((wCanvas * percentRectH) / (hCanvas * percentRectW))  ;//newRectH *
        var diffImages=newWimage-w;
        cornerNEx = parseFloat(tokens[0]) - (diffImages / 2);
        var wi=newWimage;
        var he=percentRectH;//hImage+percentY+addHimage; 
        zoominit=viewBox;
        //zoominit1 = cornerNEx+' '+cornerNEy+' '+wi+' '+he;
      //zoominit1 = (-percentX) +' '+(-percentY)+' '+wi+' '+he;
      proporx =wFront/wi;
      propory = wFront/wi; 
      var invPropor =wi/ wFront; 
     zoominit1 = (proporx*cornerNEx) +' '+(propory*cornerNEy)+' '+wi+' '+he;
      zoominit2=zoominit1; 
      var tZ = (invPropor*cornerNEx) +' '+(invPropor*cornerNEy)+' '+wi+' '+he;

       
        tokensZoom=tokensCanvas;//tZ.split(' ');//viewBox.split(' '); ;//zoominit1.split(' ');  
     }
  if(proporCanvas>proporImage)
   {    
        // add to hImage
        var newHimage = percentRectH * ((hCanvas * percentRectW) / (wCanvas * percentRectH))  ;//newRectH *
        var diffImages=newHimage-h;
        cornerNEy = parseFloat(tokens[1]) - (diffImages / 2);
        var wi=percentRectW;
        var he=newHimage;//hImage+percentY+addHimage; 
        zoominit=viewBox;                                    
      proporx =wFront/wi;
      propory = wFront/wi; 
     
     zoominit1 = (proporx*cornerNEx) +' '+(propory*cornerNEy)+' '+wi+' '+he;
     zoominit2=zoominit1; 
     tokensZoom=zoominit1.split(' '); 
 
   } 


  }
}



VMLRenderer.prototype.zoomFrame = function(zoom){ 
   myOPF.viewBox=zoom;  
   load(myOPF,c);
   document.getElementById("source").value=myOPF.toJSONString();
}
VMLRenderer.prototype.rectDoc = function(viewBox) {
     var tokens2 = zoominit2.split(' ');    
     var tokens = zoominit.split(' ');
  var shape = document.getElementById('rectDoc');
  if (shape) {
    this.remove(shape);
  } 
  var rect=this.container.ownerDocument.createElement('v:rect');
  rect.id='rectDoc';
  rect.style.position = 'absolute';
  rect.style.left =-parseInt(tokens2[0]); 
  rect.style.top = -parseInt(tokens2[1]);
  rect.style.width = parseInt(tokens[2]);
  rect.style.height = parseInt(tokens[3]);
  rect.setAttribute('filled', 'false');
   rect.setAttribute('stroked', 'true'); 
  rect.setAttribute('strokeweight', 2); 
  rect.setAttribute('strokecolor',"#ff0000"); 
   //this.container.appendChild(rect);
   //this.container.insertBefore(rect, this.container.firstChild );
  //alert(docx+' '+docy+' '+docw+' '+doch+' '+viewBox) 
}   
VMLRenderer.prototype.rectCanvas = function(docx,docy,docw,doch,viewBox) {
  
     var tokens = zoominit1.split(' ');    
  var shape = document.getElementById('rectCanvas');
  if (shape) {
    this.remove(shape);
  }
  
  var rect=this.container.ownerDocument.createElement('v:rect');
  rect.id='rectBackground'; 
  rect.style.position = 'absolute';
  rect.style.left = tokens[0] ;
  rect.style.top =tokens[1];
  rect.style.width=tokens[2];
  rect.style.height= tokens[3] ;  
  rect.setAttribute('filled', 'true');
  rect.setAttribute('fillcolor',"#666666"); 
  rect.setAttribute('stroked', 'false');  
  
   this.container.insertBefore(rect, this.container.firstChild );
  
}

VMLRenderer.prototype.removeAll = function(){
	while (this.container.hasChildNodes()) {
		this.container.removeChild(this.container.firstChild);
	}
}   

function VMLviewBox(container,left,top,width,height){
  var tokens = zoominit2.split(' ');  
  left *= proporx;
  left = left - parseFloat(tokens[0]);
  top *= propory; 
  top = top - parseFloat(tokens[1]);   
  width *= proporx;
  height *= propory; 
  
  return {"x":parseFloat(Math.round(left)), "y":parseFloat(Math.round(top)), "w":parseFloat(Math.round(width)), "h":parseFloat(Math.round(height))};
}   
function VMLviewBox1(container,left,top,width,height){
  var tokens = zoominit2.split(' ');  
  left *= proporx;
  left = left - parseFloat(tokens[0]);
  top *= propory; 
  top = top - parseFloat(tokens[1]);   
  width *= proporx;
  height *= propory; 
  
  return {"x":parseFloat(Math.round(left)), "y":parseFloat(Math.round(top)), "w":parseFloat(Math.round(width)), "h":parseFloat(Math.round(height))};
}   

VMLRenderer.prototype.create = function(shape, fillColor, lineColor, fillOpac, lineOpac, lineWidth, left, top, width, height, textMessaje, textSize, textFamily, imageHref, points, transform, parent) {
   var tokens = zoominit2.split(' ');  

   var zoom=VMLviewBox(this.container,left,top,width,height);
   
   left=zoom.x;  
   top=zoom.y;
   width=zoom.w;
   height=zoom.h;

   var zoom=VMLviewBox(this.container,left,top,textSize,textSize);
   //if(zoom.w<1){zoom.w=1}    
   if(zoom.y== undefined){left=0}
   if(zoom.x== undefined){top=0} 
   if(zoom.w== undefined){width=0}   
   if(zoom.h== undefined){height=0}
   textSize=zoom.h;  

   var zoom=VMLviewBox(this.container,left,top,lineWidth*2/3,lineWidth);
   //if(zoom.w<1){zoom.w=1}
   lineWidth=zoom.w;  
   var vml;
 var shap=1;
  if (shape == 'rect') { 
  
    vml = this.container.ownerDocument.createElement('v:rect');  
    vml.style.position = 'absolute';
    vml.style.left = left; 
    vml.style.top = top;
    vml.style.width = width;
    vml.style.height = height;
  }
  else if (shape == 'roundrect') {
            vml = this.container.ownerDocument.createElement('v:roundrect'); 
            vml.style.position = 'absolute';
            vml.style.left = left;
            vml.style.top = top;
            vml.style.width = width;    
            vml.style.height = height;
            vml.setAttribute('arcsize', '20%');   
            
  }
  else if (shape == 'ellipse') {
    vml = this.container.ownerDocument.createElement('v:oval');  
    vml.style.left = left;
    vml.style.top = top;
    vml.style.width = width; 
    vml.style.height = height;
    vml.style.position = 'absolute';
  }
  else if (shape == 'line') {  
    
    vml = this.container.ownerDocument.createElement('v:line'); 
    vml.setAttribute('from', left + 'px,' + top + 'px');
    vml.setAttribute('to', (left+width) + 'px,' + (top+height) + 'px');

  }   
  else if (shape == 'polyline') {
    vml = this.container.ownerDocument.createElement('v:polyline');
    vml.setAttribute("points", points); 
    
  }    
  else if (shape == 'path') 
   {   
    vml = this.container.ownerDocument.createElement('v:shape');  
    var tokens = zoominit1.split(' ');  
    var tokens1 = zoominit1.split(' ');         
    var tokens2 = zoominit2.split(' ');   
    tokens[0]=0;
    tokens[1]=0;
    var path=points;
    path=path.replace(/, /g, ','); 
    path=path.replace(/ ,/g, ',');
    var ps =path.split(" ")
    var pcc = "";
   
    var re = /^[-]?\d*\.?\d*$/; 
    var contArc=0; 
    var isArc=false;
    for(var i = 0; i < ps.length; i++)
    { 
     if(ps[i].indexOf(',')>0){  
      
       var point =ps[i].split(","); 
       var char1=point[0].substring(0,1); 
     
       if (!char1.match(re))        
        { 
           var num0prev= parseFloat(point[0].substring(1));
           var zoom=VMLviewBox(this.container,num0prev*1+(parseInt(tokens2[0])*0),0,parseInt(tokens2[2]),parseInt(tokens2[3]));
           num0=zoom.x;  
   
           var text=char1;
        }else{ 
            var num0prev= parseFloat(point[0]);
            var zoom=VMLviewBox(this.container,num0prev*1+(parseInt(tokens2[0])*0),0,parseInt(tokens2[2]),parseInt(tokens2[3]));
            num0=zoom.x;  
  
        }  
       point[1]= parseFloat(point[1]);  
       var zoom=VMLviewBox(this.container,0,point[1],parseInt(tokens2[2]),parseInt(tokens2[3]));
       point[1]=zoom.y;  
       var cx=num0+parseInt(tokens2[0]); 
       var cy=point[1]+parseInt(tokens2[1]);   
       pcc+=text+cx+','+cy+' ';
     }
      else
     {  
        pcc+=ps[i]+' ';
     }
   
    }
   ////////////////////   
    var thispath=pcc;
    thispath=thispath.replace(/M/g,'m');
    thispath=thispath.replace(/C/g,'c');  
    thispath=thispath.replace(/L/g,'l'); 
    thispath=thispath.replace(/z/g,'x');      
   
   //document.getElementById('source').value=points+'\r\n'+thispath +'\r\n'+'________'+'\r\n'
   var zoom=VMLviewBox(this.container,tokens[0],tokens[1],tokens[2],tokens[3]);
   
    vml.style.position="absolute";  
    vml.style.width= zoom.w+"px";
    vml.style.height=zoom.h+"px";
    vml.style.left=zoom.x+"px";  
    vml.style.top=zoom.y+"px";    
    vml.setAttribute('coordsize', zoom.w+','+zoom.h); 
 
    var path01 = this.container.ownerDocument.createElement('v:path');  
    path01.setAttribute("v", thispath+' e'); 
 
 
    
    vml.appendChild(path01)
    
   }
   
   else if (shape == 'controlpath')
   {
    
    vml = this.container.ownerDocument.createElement('v:shape');  
      vml.style.position="absolute";  
    vml.style.width= 700+"px";
    vml.style.height=500+"px";
    vml.style.left=left+"px";  
    vml.style.top=top+"px";  
    vml.setAttribute('coordsize', '700,500');   
     
    var path01 = this.container.ownerDocument.createElement('v:path');  
    path01.setAttribute('v', 'm '+left+','+top+' c'+(left+1)+','+(top+1)+' e ');  

     vml.appendChild(path01)
    } 
    else if (shape == 'image') {   
     var data =imageHref;//document.forms[0].option_text_message.value;
     vml = this.container.ownerDocument.createElement('v:image'); 
     vml.setAttribute('src',imageHref);
     vml.style.position="absolute";  
     vml.style.width=width+"px";
     vml.style.height=height+"px";
     vml.style.left=left+"px";  
     vml.style.top=top+"px";  
     vml.style.margin=0+"px";  
     vml.style.padding=0+"px";  
     if (fillColor != ''  || fillColor != 'none') {
       vml.setAttribute('filled', 'false');
       vml.setAttribute('fillcolor', fillColor);
     }
     else {
       vml.setAttribute('filled', 'false');
     }
    vml.setAttribute('strokeweight','0px');// parseFloat(lineWidth)+'px');
   vml.setAttribute('stroked', 'false');  
   vml.setAttribute('strokecolor','#000000');//lineColor);
   
   
    }
    
 else if (shape == 'text') 
  {   
   
    var data =textMessaje;
    vml = this.container.ownerDocument.createElement('v:shape');
    vml.style.position="absolute";  
    //vml.setAttribute('coordorigin',left+', '+top);
     //vml.style.coorsize= '';
     coordorigin="0, 0" 
     
     var ts=isNaN(textSize)
     if(ts==true){
     textSize=10;
     }
    vml.style.width= textSize+'px';//tokens[2]+'px'
    vml.style.height=textSize+'px';
    vml.style.left=(left+"px");  
    vml.style.top=(top-(textSize*1/4)+"px");  
    vml.style.margin=0+"px"; 
     vml.style.padding=0+"px";  
     vml.setAttribute('path','m '+0+' '+0+' r '+(textSize*data.length)+' '+0+' e'); 
     var textPathObj = this.container.ownerDocument.createElement("v:textpath");
     textPathObj.setAttribute('string', data); 
      textPathObj.setAttribute('fitshape','false'); 
     textPathObj.setAttribute('trim', 'false'); 
     textPathObj.setAttribute('fitpath', 'false');
     textPathObj.setAttribute('on','true');  
     textPathObj.style.fontFamily=textFamily;  
     textPathObj.style.fontSize=textSize+'px'; 
     textPathObj.setAttribute('vTextKern','true');  
     textPathObj.setAttribute('text-align','center');  
     
      var pathObj = this.container.ownerDocument.createElement("v:path");
     pathObj.setAttribute('textpathok', 'true');  
      vml.appendChild(textPathObj);  
     vml.appendChild(pathObj);  
    
    
  }    


    
 else if (shape == 'texto') 
  {  
    vml = this.container.ownerDocument.createElement('v:shape');
    vml.style.position="absolute";  
   
     vml.style.coordsize=1000+', '+1000;
    vml.style.width= 1000;
    vml.style.height=1000;
    vml.style.left=left;  
    vml.style.top=top-parseFloat(textSize);  
     
     vml.style.padding=0;  
    var textBox = this.container.ownerDocument.createElement("v:textbox");
     textBox.setAttribute('mso-rotate-with-shape',true)
     var divtext = this.container.ownerDocument.createElement("div");  
     divtext.style.coordorigin=0+', '+(0);      
     divtext.style.margin=0;   
     divtext.style.fontFamily=textFamily; 
     divtext.style.margin=0; 
     divtext.style.padding=0; 
     divtext.style.vRotateLetters=true;
     divtext.style.fontSize=parseFloat(textSize); 
    
     
           
    

     
    divtext.style.color=fillColor;
     
     
     
     
     
     //divtext.setAttribute('v-rotate-letters','true');
    if(transform.indexOf('rotate')>=0)
    {
     
      myRotate1=transform.split('rotate(');
      myRotate2=myRotate1[1].split(')');  
      myRotate3=myRotate2[0].split(',');  
     
      //divtext.setAttribute('mso-rotate',myRotate3[0]);
      //textBox.style.msoRotate= myRotate3[0];
      //textBox.style.centerX=myRotate3[1]; 
      //textBox.style.centerY=myRotate3[2];
      //vml.style.rotation= myRotate3[0];
      //vml.style.centerX=myRotate3[1]; 
      //vml.style.centerY=myRotate3[2];
        vml.setAttribute('rotation',myRotate3[0]+'Deg'); 
    }        

     divtext.innerHTML=textMessaje;
     textBox.appendChild(divtext);       
    
     vml.appendChild(textBox);  
    
  } 
    else if (shape == 'defs') {
   var vml; 
   
 } 
   
    else if (shape == 'group') {   
    vml = this.container.ownerDocument.createElement('v:group'); 
    vml.style.left=left+"px";  
    vml.style.top=top+"px";  
  }
 
  if(shape == 'zoom' || shape == 'defs') 
  {
        
  }else
  {   
    if(transform.indexOf('rotate')>=0)
    {
      myRotate1=transform.split('rotate(');
      myRotate2=myRotate1[1].split(')');  
      myRotate3=myRotate2[0].split(',');  
     
       vml.style.rotation= myRotate3[0]+'Deg';
       vml.style.centerX=myRotate3[1]; 
       vml.style.centerY=myRotate3[2];
       
    }                                     
       
        if(shape != 'image' )
         {      
            if (lineColor.length == 0){lineColor = 'none';} 
           if (fillColor.length == 0){fillColor = 'none';} 
           (fillColor!=''|| fillColor!=null )?vml.setAttribute('fillcolor', fillColor):vml.setAttribute('filled', 'true');

                    if (fillColor != ''  || fillColor != 'none' ) 
                    { 
                      vml.setAttribute('filled', 'true'); 
                      vml.setAttribute('fillcolor', fillColor); 
                      
                    }
                     else 
                    {
                      vml.setAttribute('filled', 'false');
                    }

         
                if(lineWidth==0 || lineWidth=='none' || lineColor== 'none' )    
                {
                  vml.setAttribute('stroked', 'false');  
                }
                 else 
                {  
                  //if(isNaN(lineColor)==false){alert('-'+lineColor+'-');lineColor='#000000';lineWidth=1;}
                  vml.setAttribute('stroked', 'true');
                  vml.setAttribute('strokecolor', lineColor);
                  vml.setAttribute('strokeweight', lineWidth);
                  var stroke = this.container.ownerDocument.createElement('v:stroke'); 
                  stroke.setAttribute("opacity", parseFloat(lineOpac));
                  vml.appendChild(stroke);
                  
                }

               if (fillOpac != '') 
                { 
                  if (fillOpac == 'none' || fillColor=='none'){fillOpac=0;}
                  var fill = this.container.ownerDocument.createElement('v:fill'); 
                  fill.setAttribute("opacity",parseFloat(fillOpac));  
                  //alert(fillOpac)
                  vml.appendChild(fill);
                }
          }     
  } 
  if(parent==''){   
   if(vml){
   this.container.appendChild(vml);}
  }else{ 
    if(document.getElementById(parent)){ 
     var parentShape = document.getElementById(parent);
     if(vml||vml!=null ){ 
      parentShape.appendChild(vml);
     } 
    } 
  }  
   //var parentDoc = document.getElementById('mydraw');
   //parentDoc.appendChild(vml);
  return vml;
};   

VMLRenderer.prototype.resize = function(shape, fromX, fromY, toX, toY) {
   var deltaX = toX - fromX;
   var deltaY = toY - fromY;  
  if (shape.tagName == 'rect' ) 
   { 
    
 
      if (deltaX < 0) {
         shape.style.left=toX + 'px';
         shape.style.width=-deltaX + 'px';
       }
        else
       {
         shape.style.width= deltaX + 'px';
       }
  
      if (deltaY < 0) 
       {
        shape.style.top=toY + 'px';
        shape.style.height=-deltaY + 'px';
       }
        else 
       {
        shape.style.height=deltaY + 'px';
       }
    }
}  
VMLRenderer.prototype.duplicate = function(shape) 
 {
   var vml;
   vml =shape.cloneNode(false);
   //vml.setAttribute('fillcolor', "#aa00aa");
   vml.setAttribute('filled', "false");
   this.container.appendChild(vml);
  return vml;
  
 };
VMLRenderer.prototype.querySelected = function(shape,centerx,centery,width,height)
{ 
 var result = true;
  var shapes='names: group, image, rect, path, ellipse, circle, text, line, ';

 //if(shape.getBBox && shape) 
  if( shapes.indexOf(' '+shape.tagName+',')>0)
  {
 
  var box =  this.bounds(shape);
 }else
 {
  return false;
 }
 var p1x = box.x;
  if(Math.abs(p1x-centerx)>width){result = false}
 
 var p1y = box.y;
 if(Math.abs(p1y-centery)>height){result = false}
 
 var p2x = box.x+box.width;
 if(Math.abs(p2x-centerx)>width){result = false}

 var p2y = box.y;
 if(Math.abs(p2y-centery)>height){result = false}
 
 var p3x = box.x+box.width;
 if(Math.abs(p3x-centerx)>width){result = false}

 var p3y = box.y+box.height;                    
 if(Math.abs(p3y-centery)>height){result = false}
  
 var p4x = box.x;
if(Math.abs(p4x-centerx)>width){result = false}
 
 var p4y = box.y+box.height;
 if(Math.abs(p4y-centery)>height){result = false}
 
 if(result)
  {
    return { 'in':result, 'cornersx': p1x+','+p2x+','+p3x+','+p4x+',' ,'cornersy': p1y+','+p2y+','+p3y+','+p4y+',' };
  }
   else
  { 
     return { 'in':result } 
  }
//center.distanceFrom(point1);
 

}

VMLRenderer.prototype.searchBoxes = function()
{  
 var base = this.container;

 var  NumNodes = base.childNodes.length;
 var chain= '';
 for(i = 0;i < NumNodes;i++)
  {       
     if (this.bounds(base.childNodes[i]))
      {
        chain+=base.childNodes[i].id + ';'
      }
  }
  chain+=''
  return chain;

}  

VMLRenderer.prototype.DrawBorder= function(numNode, targetElement )
{   
  var shapes='names: group, image, rect, path, ellipse, circle, text, line, ';

 //if(shape.getBBox && shape) 
  if( shapes.indexOf(' '+targetElement.tagName+',')>0)
  {
   var bbox = this.bounds(targetElement);

   var outline = this.container.ownerDocument.createElement('v:rect');  
   outline.setAttribute('x', bbox.x - 2 );
   outline.setAttribute('y', bbox.y - 2 );
   outline.setAttribute('width',  bbox.width + 4 );
   outline.setAttribute('height', bbox.height + 4 );
   outline.setAttribute('stroke', '#ff00ff' );
   outline.setAttribute('fill', 'none' );
   outline.setAttribute('id', 'shapeBoxed'+numNode );

   targetElement.parentNode.insertBefore( outline, targetElement );
   return 'shapeBoxed'+numNode; 
  } 
   else 
  {
   return false
  }
}


VMLRenderer.prototype.getMarkup = function() { 
      
  //return this.container.parentNode.innerHTML;  
  return this.container.innerHTML;
}

VMLRenderer.prototype.remove = function(shape) {
  if(shape!=null){ shape.removeNode(true); }
} 

VMLRenderer.prototype.removeAll = function() {  
 while( this.container.hasChildNodes () ){
   this.container.removeChild( this.container.firstChild );
   //this.container.removeNode( this.container.firstChild );
 } 
}

VMLRenderer.prototype.editCommand = function(shape, cmd, value)
{
  if (shape != null) {
    if (cmd == 'fillcolor') {
      if (value == '' || value =='none')
        shape.style.fill='none';
      else
        shape.style.fill=value;
    }
    else if (cmd == 'linecolor') {
      if (value != '')
        shape.style.stroke=value;
      else
        shape.style.stroke='none';
    }
    else if (cmd == 'linewidth') { 
      if( value=='none' || value=='')
       {
        shape.style.strokeWidth=0;
       }else{
        shape.style.strokeWidth=parseInt(value) + 'px';
       } 
    } 
    else if (cmd == 'fillopacity') {
           if(shape.tagName=='image')
            {
             shape.style.opacity=parseFloat(value);
            }
             else
            {
                shape.style.fillOpacity=parseFloat(value);
            }    
      
    }
    else if (cmd == 'lineopacity') {         
      
      shape.style.strokeOpacity=parseFloat(value);
      
    }
    else if (cmd == 'filter') 
     {
       if (value != '')
        {                
        //shape.style.setProperty("filter", value) ;
         shape.style.filter=value;
         //alert(value)
        }
     }  
    else if (cmd == 'textContent') 
     {
       if (value != '')
        {                
         shape.textContent=value;
        }
     }   
     else if (cmd == 'textSize') 
     {
       if (value != '')
        {                
          shape.style.fontSize=parseFloat(eval(value));
        }
     }
     else if (cmd == 'textFamily') 
     {
       if (value != '')
        {                
          shape.style.fontFamily=value;
        }
     } 
    else if (cmd == 'textSpacing') 
     {
       if (value != '')
        {                
          shape.style.letterSpacing=''+value+'em';
          //alert(value) //bad letter-spacing word-spacing
        }
     } 
    else if (cmd == 'textLength') 
     {
       if (value != '')
        {                
          //shape.style.=''+value+'';
          shape.style.lengthAdjust='spacing';//spacing spacingAndGlyphs
          //alert(value) //bad textLength
        }
     } 
     
     
    else if (cmd == 'textAnchor') 
     {
       if (value != '')
        {                
          shape.style.textAnchor=value;
        }
     }
    else if (cmd == 'textWeight') 
     {
       if (value != '')
        {                
          shape.style.fontWeight=value;
        }
     }  
    else if (cmd == 'textStyle') 
     {
       if (value != '')
        {                
          shape.style.fontStyle=value;
        }
     }
    else if (cmd == 'textDecoration') 
     {
       if (value != '')
        {                
          shape.style.textDecoration=value;
        }  
          //alert(value) //bad  textDecoration
     }                  
    else if (cmd == 'textMode') 
     {
       if (value != '')
        {                
          shape.style.writingMode=value;
        }
     } 
    else if (cmd == 'textDirection') 
     {
       if (value != '')
        {                
          shape.style.direction=value;
        }
     }  
    else if (cmd == 'textOrientation') 
     {
       if (value != '')
        {                
          shape.style.glyphOrientationVertical=value;
        }
     } 
    else if (cmd == 'stopcolor') 
     {
       if (value != '')
        {                
          shape.style.stopColor=value;
        }
     } 
    else if (cmd == 'linearGradient') 
     {
       if (value != '')
        { 
          shape.style.x1=value.x1;
          shape.style.y1=value.y1;
          shape.style.x2=value.x2;
          shape.style.y2=value.y2;
        }
     }  
    else if (cmd == 'radialGradient') 
     {
       if (value != '')
        { 
          shape.style.x1=value.x1;
          shape.style.y1=value.y1;
          shape.style.x2=value.x2;
          shape.style.y2=value.y2;
        }
     }  
    else if (cmd == 'leftTop') 
     {
       if (value != '')
        { 
          shape.style.left=parseInt(value.left)+'px';
          shape.style.top=parseInt(value.top)+'px';
          
        }
     }  
    else if (cmd == 'cxcy') 
     {
       if (value != '')
        { 
          shape.style.cx=value.cx;
          shape.style.cy=value.cy;
          
        }
     }  
 
  }
}


VMLRenderer.prototype.queryCommand = function(shape, cmd)
{
  var result = '';
  
  if (shape != null) {
    if (cmd == 'fillcolor') {
      result = shape.style.fill;
      if (result == 'none')
        result = '';
    }
    else if (cmd == 'linecolor') {
      result = shape.style.stroke;
      if (result == 'none')
        result = '';
    }
    else if (cmd == 'linewidth') {
      result = shape.style.stroke;
      if (result == 'none')
        result = '';
      else
        result = shape.style.strokeWidth;
    }
    else if (cmd == 'fillopacity') {
           if(shape.tagName=='image')
            {
             result= shape.style.opacity;
            }
             else
            {
             result= shape.style.fillOpacity;
            }    
      
    }
    else if (cmd == 'lineopacity') {         
      
     result= shape.style.strokeOpacity;
      
    }
    else if (cmd == 'text') {         
         var text1=shape.textContent;
         var text2=shape.style.fontFamily;
         var text3=parseInt(shape.style.fontSize);
      
      result= {"data":text1,"family":text2,"size":text3};
      
    } 
    else if (cmd == 'points') {         
         result=shape.style,d;
      
    }    
    else if (cmd == 'stopcolor') {         
         result=shape.style.stopColor
      
    }
    else if (cmd == 'box') {         
      result= this.bounds(shape);
      
    }
    else if (cmd == 'linearGradient') {         
         var x1=shape.style.x1;
         var y1=shape.style.y1;
         var x2=shape.style.x2;
         var y2=shape.style.y2;
      result= {"x1":x1,"y1":y1,"x2":x2,"y2":y2};
      
    }
 
 
  }
  
  return result;
} 

 VMLRenderer.prototype.showTracker01 = function(shape) {
  var box = this.bounds(shape);

  var tracker = document.getElementById('tracker');
  if (tracker) {
    this.remove(tracker);
  }

  tracker = this.container.ownerDocument.createElement('v:rect');
  tracker.id = 'tracker';
  tracker.style.position = 'absolute';
  tracker.style.left = box.x - 10;
  tracker.style.top = box.y - 10;
  tracker.style.width = box.width + 20;
  tracker.style.height = box.height + 20;
  tracker.setAttribute('filled', 'false');
  tracker.setAttribute('stroked', 'true');
  tracker.setAttribute('strokecolor', 'blue');
  tracker.setAttribute('strokeweight', '1px');
  this.container.appendChild(tracker);
}


VMLRenderer.prototype.showTracker = function(shape) {
  var box = this.bounds(shape);  
   //alert(box.width+' '+shape.id)
  var trshape = parseFloat(shape.getAttribute('rotation'));  
  var tracker = document.getElementById('tracker');

  if (tracker) {
    this.remove(tracker);
  }
  
  if (shape.tagName == 'shape') 
   { 
      shap=2; 
      if(shape.children[0].tagName == 'path') 
       {
      
            /* $('option_path_trx').value= box.x;  
             $('option_path_try').value= box.y;
             $('option_path_sclx').value= box.width;   
             $('option_path_scly').value= box.height; 
             $('option_path_rot').value= shape.style.rotation;
             */  
             //var path=shape.children[0].getAttribute('v');
             // $('control_codebase').value=path;
       }        
   }     
  if (shape.tagName == 'rect') { 
   /*  
     $('option_rect_rot').value= shape.getAttribute('rotation');
     $('option_rect_trx').value= box.x;  
     $('option_rect_try').value= box.y;
     $('option_rect_sclx').value= box.width;  
     $('option_rect_scly').value= box.height;
     */
  }  

  if (shape.tagName == 'image'){
  /*  $('option_img_trx').value= box.x; 
    $('option_img_try').value= box.y;
    $('option_img_sclx').value= box.width;  
    $('option_img_scly').value= box.height;
    $('option_img_rot').value= T.b* (Math.PI * 2 / 360);   
      */
  }
  if (shape.tagName == 'text'){
   /* f$('option_text_trx').value= box.x; 
    $('option_text_try').value= box.y;
    $('option_text_sclx').value= box.width;  
    $('option_text_scly').value= box.height;
    $('option_text_rot').value= T.b* (Math.PI * 2 / 360);
   */
  }
  if (shape.tagName == 'line'){ 
    /*
    $('option_line_trx').value= box.x;  
    $('option_line_try').value= box.y;
    */
  }   
  if (shape.tagName == 'oval'){  
    /*$('option_ellipse_trx').value= putx;  
    $('option_ellipse_try').value= puty;
    $('option_ellipse_sclx').value= box.width;  
    $('option_ellipse_scly').value= box.height;
    $('option_ellipse_rot').value= T.b* (Math.PI * 2 / 360);
    */
  }
  
  
  
 /*var matrix = shape.getScreenCTM();
  var trshape= shape.getAttribute('transform');  
  var shap=1;
  if (shape.tagName == 'path') { shap=2; 
        
        
        
  }
  */  
  //if (shape.getAttribute('transform') ) { shap=2; } 
  //var svgNamespace = 'http://www.w3.org/2000/svg';
  
   tracker = this.container.ownerDocument.createElement('v:group');
   tracker.id = 'tracker'; 
  //tracker.setAttribute('rotation',trshape);
  tracker.setAttribute('coordorigin','0, 0');
  //tracker.setAttribute('wrapcoords',true);
 
   
  tracker.setAttribute('coordsize',box.width+','+ box.height);
  tracker.style.position = 'absolute';   
  tracker.style.left = box.x ;
  tracker.style.top = box.y;
  tracker.style.width = box.width ;
  tracker.style.height = box.height ;
 
     
    ////////////////

                                         
 var corners = [];
  var point = createPoint(box.x, box.y, box.width, box.height);
 //point = {x:box.x, y:box.y, width: box.width, height:box.height};
//point = createPoint(box.x, box.y, box.width, box.height);    
  //1
  corners.push( createPoint(box.x + box.width, box.y, box.width, box.height) );
  point.x = box.x + box.width;
  point.y = box.y;
  //2
  corners.push( createPoint(box.x + box.width, box.y + box.height, box.width, box.height) );
  point.x = box.x + box.width;
  point.y = box.y + box.height;
  //3
  //corners.push( point.matrixTransform(matrix) );
  corners.push( createPoint(box.x , box.y + box.height, box.width, box.height) );
  point.x = box.x;
  point.y = box.y + box.height;
  //4
  corners.push( createPoint(box.x + box.width, box.y, box.width, box.height) );   
  
  var max = createPoint(corners[0].x, corners[0].y);
  var min = createPoint(corners[0].x, corners[0].y);
  
  for (var i = 1; i < corners.length; i++) {
    var x = corners[i].x;
    var y = corners[i].y;
    if (x < min.x) {
      min.x = x;
    }
    else if (x > max.x) {
      max.x = x;
    }
    if (y < min.y) {
      min.y = y;
    }
    else if (y > max.y) {
      max.y = y;
    }
  } 
      
      
 var border_square = this.container.ownerDocument.createElement('v:rect');
  
  border_square.style.position = 'relative';
  border_square.style.left = 0 - 10;
  border_square.style.top = 0 - 10;
  border_square.style.width = box.width + 20;
  border_square.style.height = box.height + 20;
  border_square.setAttribute('filled', 'false');
  border_square.setAttribute('stroked', 'true');
  border_square.setAttribute('strokecolor', 'blue');
  border_square.setAttribute('strokeweight', '1px');  
  
  
  var border_angle = this.container.ownerDocument.createElement('v:polyline');  
  border_angle.style.position = 'relative';
 
  border_angle.setAttribute('filled', 'false');
  border_angle.setAttribute('stroked', 'true');
  border_angle.setAttribute('strokecolor', 'blue');
  border_angle.setAttribute('strokeweight', '1px'); 
  border_angle.setAttribute("points", (box.width+10)+","+((box.height/2))+", "+(box.width+10+25)+","+((box.height/2)) );
                  

     var circle1 = this.container.ownerDocument.createElement('v:oval'); 
      circle1.style.position = 'relative'; 
        circle1.style.left = ( (box.width+40)-5);
    circle1.style.top = ( (box.height / 2) -5);
    circle1.style.width = (10);
    circle1.style.height = (10);
    circle1.setAttribute('filled', 'true');
   circle1.setAttribute('stroked', 'true'); 
   circle1.setAttribute('fillcolor', '#ffffff');
   circle1.setAttribute('strokecolor', 'green');
   circle1.setAttribute('strokeweight', '1px');

   
  var rect1 = this.container.ownerDocument.createElement('v:rect');
  rect1.style.position = 'relative';
  rect1.style.left =  - 10-5;
  rect1.style.top =  - 10-5;
  rect1.style.width = 10;
  rect1.style.height = 10;
  rect1.setAttribute('filled', 'true');
  rect1.setAttribute('stroked', 'true'); 
  rect1.setAttribute('fillcolor', '#ffffff');
  rect1.setAttribute('strokecolor', 'green');
  rect1.setAttribute('strokeweight', '1px');

    
  var rect2 = this.container.ownerDocument.createElement('v:rect');
  rect2.style.position = 'relative';
  rect2.style.left =   box.width +5;
  rect2.style.top = -10 -5;
  rect2.style.width = 10;
  rect2.style.height = 10;
  rect2.setAttribute('filled', 'true');
  rect2.setAttribute('stroked', 'true'); 
  rect2.setAttribute('fillcolor', '#ffffff');
  rect2.setAttribute('strokecolor', 'green');
  rect2.setAttribute('strokeweight', '1px');

                                                        
  var rect3 = this.container.ownerDocument.createElement('v:rect');
  rect3.style.position = 'relative';
  rect3.style.left =   box.width+5;
  rect3.style.top =  box.height+5;
  rect3.style.width = 10;
  rect3.style.height = 10;
  rect3.setAttribute('filled', 'true');
  rect3.setAttribute('stroked', 'true'); 
  rect3.setAttribute('fillcolor', '#ffffff');
  rect3.setAttribute('strokecolor', 'green');
  rect3.setAttribute('strokeweight', '1px');
   
  var rect4 = this.container.ownerDocument.createElement('v:rect');
  rect4.style.position = 'relative';
  rect4.style.left =  -10-5;
  rect4.style.top = box.height+5;
  rect4.style.width = 10;
  rect4.style.height = 10;
  rect4.setAttribute('filled', 'true');
  rect4.setAttribute('stroked', 'true'); 
  rect4.setAttribute('fillcolor', '#ffffff');
  rect4.setAttribute('strokecolor', 'green');
  rect4.setAttribute('strokeweight', '1px');
 
 
 
  var rectmid12 = this.container.ownerDocument.createElement('v:rect');
  rectmid12.style.position = 'relative';
  rectmid12.style.left = (box.width/2) -5;
  rectmid12.style.top =- 10-5;
  rectmid12.style.width = 10;
  rectmid12.style.height = 10;
  rectmid12.setAttribute('filled', 'true');
  rectmid12.setAttribute('stroked', 'true'); 
  rectmid12.setAttribute('fillcolor', '#ffffff');
  rectmid12.setAttribute('strokecolor', 'green');
  rectmid12.setAttribute('strokeweight', '1px');

 var rectmid23 = this.container.ownerDocument.createElement('v:rect');
  rectmid23.style.position = 'relative';
  rectmid23.style.left = box.width +5;
  rectmid23.style.top = (box.height/2)-5;
  rectmid23.style.width = 10;
  rectmid23.style.height = 10;
  rectmid23.setAttribute('filled', 'true');
  rectmid23.setAttribute('stroked', 'true'); 
  rectmid23.setAttribute('fillcolor', '#ffffff');
  rectmid23.setAttribute('strokecolor', 'green');
  rectmid23.setAttribute('strokeweight', '1px');

 var rectmid34 = this.container.ownerDocument.createElement('v:rect');
  rectmid34.style.position = 'relative';
  rectmid34.style.left = (box.width/2)-5;
  rectmid34.style.top = box.height+5;
  rectmid34.style.width = 10;
  rectmid34.style.height = 10;
  rectmid34.setAttribute('filled', 'true');
  rectmid34.setAttribute('stroked', 'true'); 
  rectmid34.setAttribute('fillcolor', '#ffffff');
  rectmid34.setAttribute('strokecolor', '#000000');
  rectmid34.setAttribute('strokeweight', '1px');

 
 var rectmid41 = this.container.ownerDocument.createElement('v:rect');
  rectmid41.style.position = 'relative';
  rectmid41.style.left =  -10-5 ;
  rectmid41.style.top =(box.height/2)-5;
  rectmid41.style.width = 10;
  rectmid41.style.height = 10;
  rectmid41.setAttribute('filled', 'true');
  rectmid41.setAttribute('stroked', 'true'); 
  rectmid41.setAttribute('fillcolor', '#ffffff');
  rectmid41.setAttribute('strokecolor', 'green');
  rectmid41.setAttribute('strokeweight', '1px');
  
       
  

     var colorin="#ff0000";
      var colorout="#ffffff" 
    
        circle1.attachEvent("onmouseover", function(event) {circle1.style.cursor= 's-resize';  circle1.setAttribute('fillcolor', colorin ); typeTransform='Rotate'; scaleType='nw'; }, false);
     circle1.attachEvent("onmouseout", function(event) {circle1.style.cursor= 'default';  circle1.setAttribute('fillcolor', colorout ); typeTransform='Rotate'; }, false); //typeTransform='rotate'
     
      
     rect1.attachEvent("onmouseover", function(event) {rect1.style.cursor= 'nw-resize';  rect1.setAttribute('fillcolor', colorin ); typeTransform='Scale'; scaleType='nw';  }, false);
     rect1.attachEvent("onmouseout", function(event) {rect1.style.cursor= 'default';  rect1.setAttribute('fillcolor', colorout ); typeTransform='Scale';  }, false); //typeTransform='rotate'
    
     rect2.attachEvent("onmouseover", function(event) {rect2.style.cursor= 'ne-resize';  rect2.setAttribute('fillcolor', colorin ); typeTransform='Scale'; scaleType='ne';}, false);  
     rect2.attachEvent("onmouseout", function(event) {rect2.style.cursor= 'default';  rect2.setAttribute('fillcolor', colorout ); typeTransform='Scale'; }, false);
      
     rect3.attachEvent("onmouseover", function(event) {rect3.style.cursor= 'se-resize';  rect3.setAttribute('fillcolor', colorin ); typeTransform='Scale'; scaleType='se';}, false);  
     rect3.attachEvent("onmouseout", function(event) {rect3.style.cursor= 'default';  rect3.setAttribute('fillcolor', colorout ); typeTransform='Scale'; }, false);
     
     rect4.attachEvent("onmouseover", function(event) {rect4.style.cursor= 'sw-resize';  rect4.setAttribute('fillcolor', colorin ); typeTransform='Scale'; scaleType='sw';}, false);  
     rect4.attachEvent("onmouseout", function(event) {rect4.style.cursor= 'default';  rect4.setAttribute('fillcolor', colorout ); typeTransform='Scale'; }, false);
                                                    
     rectmid12.attachEvent("onmouseover", function(event) {rectmid12.style.cursor= 'n-resize';  rectmid12.setAttribute('fillcolor', colorin ); typeTransform='Scale'; scaleType='n';}, false);  
     rectmid12.attachEvent("onmouseout", function(event) {rectmid12.style.cursor= 'default';  rectmid12.setAttribute('fillcolor', colorout ); typeTransform=''; }, false); 

     rectmid23.attachEvent("onmouseover", function(event) {rectmid23.style.cursor= 'e-resize';  rectmid23.setAttribute('fillcolor', colorin ); typeTransform='Scale'; scaleType='e';}, false);  
     rectmid23.attachEvent("onmouseout", function(event) {rectmid23.style.cursor= 'default';  rectmid23.setAttribute('fillcolor', colorout ); typeTransform=''; }, false); 
     
     rectmid34.attachEvent("onmouseover", function(event) {rectmid34.style.cursor= 's-resize';  rectmid34.setAttribute('fillcolor', colorin ); typeTransform='Scale'; scaleType='s';}, false);  
     rectmid34.attachEvent("onmouseout", function(event) {rectmid34.style.cursor= 'default';  rectmid34.setAttribute('fillcolor', colorout ); typeTransform=''; }, false); 

     rectmid41.attachEvent("onmouseover", function(event) {rectmid41.style.cursor= 'w-resize';  rectmid41.setAttribute('fillcolor', colorin ); typeTransform='Scale'; scaleType='w'; }, false);  
     rectmid41.attachEvent("onmouseout", function(event) {rectmid41.style.cursor= 'default';  rectmid41.setAttribute('fillcolor', colorout ); typeTransform=''; }, false); 
   //tracker.setAttribute('transform',trshape); 
 
   
  
  tracker.appendChild(border_square); 
  tracker.appendChild(border_angle);  
   
  tracker.appendChild(circle1);  
  
  tracker.appendChild(rect1);    
  tracker.appendChild(rect2);   
  tracker.appendChild(rect3); 
  tracker.appendChild(rect4);    
  tracker.appendChild(rectmid12);  
  tracker.appendChild(rectmid23);
  tracker.appendChild(rectmid34);
  tracker.appendChild(rectmid41);  
  
  /*
   
  
 
  */

   //alert(shape.id)
   this.container.appendChild(tracker);
  


}                                      
